import { Action } from 'redux';
import { DevtoolsInspectorProps } from './DevtoolsInspector';
declare const UPDATE_MONITOR_STATE = "@@redux-devtools-inspector/UPDATE_MONITOR_STATE";
interface UpdateMonitorStateAction {
    type: typeof UPDATE_MONITOR_STATE;
    monitorState: Partial<DevtoolsInspectorState>;
}
export declare function updateMonitorState(monitorState: Partial<DevtoolsInspectorState>): UpdateMonitorStateAction;
export declare type DevtoolsInspectorAction = UpdateMonitorStateAction;
export interface DevtoolsInspectorState {
    selectedActionId: number | null;
    startActionId: number | null;
    inspectedActionPath: (string | number)[];
    inspectedStatePath: (string | number)[];
    tabName: string;
    searchValue?: string;
}
export declare const DEFAULT_STATE: DevtoolsInspectorState;
export declare function reducer<S, A extends Action<unknown>>(props: DevtoolsInspectorProps<S, A>, state: DevtoolsInspectorState | undefined, action: DevtoolsInspectorAction): {
    selectedActionId: number | null;
    startActionId: number | null;
    inspectedActionPath: (string | number)[];
    inspectedStatePath: (string | number)[];
    tabName: string;
    searchValue?: string | undefined;
};
export {};
